//+------------------------------------------------------------------+
//|                                              		    eMarti.mq5 |
//|              Copyright Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include "ExpertAdvisor.mqh"
#include <Trade\DealInfo.mqh>

input double Lots=0.1;  // 
input double LotKoef=2; //     
input int Dist=60;      //     
//---
class CMartiEA : public CExpertAdvisor
  {
protected:
   double            m_lots;       // 
   double            m_lotkoef;    //     
   int               m_dist;       //     
   CDealInfo         m_deal;       //  
   bool              m_first;      //    

public:
   void CMartiEA() { }
   void ~CMartiEA() { }
   virtual bool      Init(string smb,ENUM_TIMEFRAMES tf); // 
   virtual void      OpenPosition();
   virtual void      CheckPosition();
  };
//------------------------------------------------------------------	Init
bool CMartiEA::Init(string smb,ENUM_TIMEFRAMES tf)
  {
   if(!CExpertAdvisor::Init(0,smb,tf)) return(false); //   
   m_lots=Lots; m_lotkoef=LotKoef; m_dist=Dist;       //  
   m_deal.Ticket(0); m_first=true;
   m_bInit=true; return(true);                        // " "
  }
//------------------------------------------------------------------	OnTrade
void CMartiEA::OpenPosition()
  {
   if(!CExpertAdvisor::Main()) return;                       //   
   if(!m_first) return;                                      //     
   ulong deal=DealOpen(ORDER_TYPE_BUY,m_lots,m_dist,m_dist); //   
   if(deal>0) { m_deal.Ticket(deal); m_first=false; }        //   
  }
//------------------------------------------------------------------	OnTrade
void CMartiEA::CheckPosition()
  {
   if(!CExpertAdvisor::Main()) return; //   
   if(m_first) return;                 //      
   if(PositionSelect(m_smb)) return;   //   

   //    
   double lot=m_lots;                       //  
   long dir=m_deal.Type();                  //  
   if(CountProfitByDeal(m_deal.Ticket())<0) //   
     {
      lot=NormalLot(m_lotkoef*m_deal.Volume()); //  
      dir=ReversType(m_deal.Type());            //  
     }
   ulong deal=DealOpen(dir,lot,m_dist,m_dist); //  
   if(deal>0) m_deal.Ticket(deal);             //  
  }

CMartiEA ea; //  
//------------------------------------------------------------------	OnInit
int OnInit()
  {
   ea.Init(Symbol(),Period()); //  
   return(0);
  }
//------------------------------------------------------------------	OnDeinit
void OnDeinit(const int reason) { }
//------------------------------------------------------------------	OnTick
void OnTick()
  {
   ea.OpenPosition(); //   -   
  }
//------------------------------------------------------------------	OnTrade
void OnTrade()
  {
   ea.CheckPosition(); //   
  }